#include "../Internals/trakr.h"
#include "BinFileHeader.h"

/*
#define Voltage1    570
#define Voltage2    520
#define Voltage3    470
#define Voltage4    420
*/
#define Voltage1    520
#define Voltage2    490
#define Voltage3    455
#define CMD_CIR     (0x1<<0)
#define CMD_BATB    (0x1<<1)
#define CMD_BATL    (0x1<<2)
#define CMD_DIRB    (0x1<<3)
#define CMD_DIRL    (0x1<<4)
#define CMD_SPEEDB  (0x1<<5)
#define CMD_SPEEDL  (0x1<<6)

unsigned int uiKeyStatus;
unsigned int uiKeyOldStatus;
volatile unsigned int iMode;
volatile unsigned int iModeBuf;
volatile unsigned int iModeTmp;
volatile unsigned int BatIndex,SpeedIndex,DirIndex;
volatile unsigned int BatBuf,SpeedBuf,DirBuf;
volatile unsigned int VoltageSum;
volatile unsigned int uiTimer0Count;
volatile unsigned int uiTimer;
volatile unsigned short Voltage;
volatile unsigned int uiTimer0Count;
volatile unsigned short usMaxBat;

extern void Overlap_Bitmap(unsigned long YUV,unsigned long ulWidth,unsigned long ulHeight);
extern bool Remote_Key_Function(unsigned int Key);
extern void Change_Dir(void);
extern void Direction_Turn_Right(void);
extern void Direction_Turn_Left(void);
extern void Change_Speed(unsigned int uiTimer);
extern void Update_Remote(void);
extern void Detect_Voltage(unsigned short Voltage);
extern void Update_ROse_Cmds(void);
TAG_COLOR ColorTP={0x0,0x0,0x20,0x0};
TAG_BMP_POS *pbmp;
bool IR;

bool Setup(void)
{
  unsigned int i,j;
  SVT_ROsd_Pack_Bmps_Open();
  for(i=0;i<GROUP_COUNT;i++)
  {
    pbmp=(TAG_BMP_POS *)pBmp_Group[i];
    for(j=0;j<pbmp->count;j++)
    {
      SVT_ROsd_Pack_Bmps((char*)*(pbmp->ps+j),*(pbmp->pe+j)-*(pbmp->ps+j));
    }
  }
  SVT_ROsd_Pack_Bmps_Send();
  SVT_ROsd_Pack_Bmps_Close();
  SVT_ROsd_Open();
  JAPI_SetRCKeyCtrl((unsigned char)((Key_Input2|Key_Menu)>>8));
  JAPI_SetRCSnd(1);
  JAPI_SetRCIcon(0xff-DIconIRled);
  JAPI_GetIRCtrl();
  JAPI_IRoff();
  iMode=0;
  BatIndex=0;
  SpeedIndex=0;
  DirIndex=0;
  return true;
}
void Unsetup(void)
{
  JAPI_IRoff();
  JAPI_QuitIRCtrl();
  JAPI_SetRCKeyCtrl(0);
  JAPI_SetRCIcon(0);
  SVT_ROsd_Close();
}
bool Run(void)
{
  bool loop=true;
  IR=false;
  JAPI_ResetTimer0();
  JAPI_ResetTimer1();
  JAPI_ResetTimer2();
  VoltageSum=0;
  uiTimer0Count=290;
  BatBuf=0xff;
  SpeedBuf=0xff;
  DirBuf=0xff;
  iModeBuf=0xff;
  Update_ROse_Cmds();
  SVT_ROsd_Send_Cmd_Times(300);
  usMaxBat=0xffff;
  while(loop==true)
  {
    Update_Remote();
    uiKeyStatus=JAPI_GetCtrlStatus();
    if((uiKeyStatus&(0x1ff<<8))!=uiKeyOldStatus)
      loop=Remote_Key_Function(uiKeyStatus&(0x1ff<<8));
    if(IR==true)
      JAPI_IRon();
    else
      JAPI_IRoff();
    if(JAPI_GetTimer2()>340)
    {
      JAPI_ResetTimer2();
      Change_Dir();
    }
    if((uiKeyStatus&0xff)==0)
    {
      JAPI_ResetTimer1();
      uiTimer=0;
      SpeedIndex=0;
      if(JAPI_GetTimer0()>200)
      {
        JAPI_ResetTimer0();
        uiTimer0Count++;
        if(uiTimer0Count>=10)
        {
          //VoltageSum=(unsigned int)(JAPI_ReadBatteryVoltage());
          uiTimer0Count=0;
          //Detect_Voltage(VoltageSum);
        }
      }
    }
    else
    {
      JAPI_ResetTimer0();
      VoltageSum=0;
      //uiTimer0Count=0;
    }
    if(JAPI_GetTimer1()>50)
    {
      JAPI_ResetTimer1();
      Change_Speed(uiTimer);
      uiTimer++;
      if(uiTimer>20)
        uiTimer=20;
    }
  }
  return false;
}
void Detect_Voltage(unsigned short Voltage)
{
  //Voltage=(unsigned short)(VoltageSum/2);
  if(Voltage>usMaxBat)
  {
    Voltage=usMaxBat;
  }
  usMaxBat=Voltage;
  if(Voltage>Voltage1)
    BatIndex=1;
  else if(Voltage>Voltage2)
    BatIndex=2;
  else if(Voltage>Voltage3)
    BatIndex=3;
  else
    BatIndex=4;
}
bool Remote_Key_Function(unsigned int Key)
{
  Key=((Key^uiKeyOldStatus)&(0x1ff<<8))&Key;
  if(Key&Key_Select)
  {
    if(iMode==3)
      iMode=0;
    else
      iMode=3;
  }
  if(Key&Key_Input1)
  {
    //IR=!IR;
    DirIndex=0;
  }
  if(Key&Key_Home)
  {
    return false;
  }
  uiKeyOldStatus=Key;
  return true;
}
void Change_Speed(unsigned int uiTimer)
{
}
void Change_Dir(void)
{
  if((uiKeyStatus&0x80)!=0)
  {
    //left backward
    if((uiKeyStatus&0x8)!=0)
    {
      //right backward;
      //keep same.
    }
    else if((uiKeyStatus&0x7)!=0)
    {
      //right foreward
      Direction_Turn_Left();
      Direction_Turn_Left();
    }
    else
    {
      //rightstop
      Direction_Turn_Left();
    }
  }
  else if((uiKeyStatus&0x70)!=0)
  {
    //left foreward 
    if((uiKeyStatus&0x8)!=0)
    {
      //right backward;
      //keep same.
      Direction_Turn_Right();
      Direction_Turn_Right();
    }
    else if((uiKeyStatus&0x7)!=0)
    {
      //right foreward.
      //keep same.
    }
    else
    {
      //rightstop
      Direction_Turn_Right();
    }
  }
  else
  {
    //left stop
    if((uiKeyStatus&0x8)!=0)
    {
      //right backward;
      //keep same.
      Direction_Turn_Right();
    }
    else if((uiKeyStatus&0x7)!=0)
    {
      //right foreward.
      Direction_Turn_Left();
    }
    else
    {
      //rightstop
      //keep same.
    }
  }
}
void Direction_Turn_Right(void)
{
  DirIndex++;
  if(DirIndex>15)
    DirIndex=0;
}
void Direction_Turn_Left(void)
{
  if(DirIndex==0)
    DirIndex=16;
  DirIndex--;
}
void Update_Remote(void)
{
  if(SVT_ROsd_Is_Cmd_Sent()==false)
  {
    SVT_ROsd_Send_Cmd();
    return;
  }
  Update_ROse_Cmds();
}
void Update_ROse_Cmds(void)
{
  if((DirIndex==DirBuf)&&(iMode==iModeBuf))
    return;
  DirBuf=DirIndex;
  iModeBuf=iMode;
  SVT_ROsd_Clear_Screen();
  if(iMode==3)
  {
    pbmp=(TAG_BMP_POS*)pBmp_Group[2];
    SVT_ROsd_Draw_Bitmap(DIRB_START_INDEX,52,25,&ColorTP);
    SVT_ROsd_Draw_Bitmap(DirIndex+DIRB_START_INDEX+1,pbmp->x,pbmp->y,&ColorTP);
  }
  else
  {
    pbmp=(TAG_BMP_POS*)pBmp_Group[3];
    SVT_ROsd_Draw_Bitmap(DIRL_START_INDEX,pbmp->x,pbmp->y,&ColorTP);
    SVT_ROsd_Draw_Bitmap(DirIndex+DIRL_START_INDEX+1,pbmp->x,pbmp->y,&ColorTP);
  }
  SVT_ROsd_Show();
}

